#include <bits/stdc++.h>
using namespace std;

#define TRACE(x) cerr << #x << " = " << x << endl
#define _ << " _ " <<

typedef long long ll;

const ll BASE = 1e18;
struct BigInt {
    vector<ll> d;

    BigInt(ll num) {
        while (num > 0) {
            d.push_back(num % BASE);
            num /= BASE;
        }
    }

    BigInt& operator+=(const BigInt& other) {
        for (int i = 0; i < (int)other.d.size(); i++) {
            if ((int)d.size() == i) d.push_back(0);
            d[i] += other.d[i];

            if (d[i] >= BASE) {
                d[i] -= BASE;
                if ((int)d.size() == i + 1) d.push_back(0);
                d[i + 1]++;
            }
        }
        return *this;
    }
};

ostream& operator<<(ostream& os, const BigInt& bigint) {
    for (int i = (int)bigint.d.size() - 1; i >= 0; i--)
        os << bigint.d[i];
    return os;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll r1, s1, r2, s2;
    cin >> r1 >> s1 >> r2 >> s2;

    ll cur_num = 1;
    BigInt first_col(0);
    for (int i = 1; i <= r2; i++) {
        if (i > 1) cur_num += i - (i % 2) - 1;
        if (i >= r1) first_col += cur_num;
    }
        
    BigInt cur_col = first_col, sol(0);
    for (int i = 1; i <= s2; i++) {
        if (i > 1) cur_col += 2 * (r2 - r1 + 1);
        if (i >= s1) sol += cur_col;
    }

    cout << sol << '\n';

    return 0;
}

